type t = VisualBasic

(** {{:https://learn.microsoft.com/en-us/dotnet/visual-basic/language-reference/keywords/}} *)
let reserved_keywords =
  [
    "AddHandler";
    "AddressOf";
    "Alias";
    "and";
    "And";
    "AndAlso";
    "As";
    "Boolean";
    "ByRef";
    "Byte";
    "ByVal";
    "Call";
    "Case";
    "Catch";
    "CBool";
    "CByte";
    "CChar";
    "CDate";
    "CDbl";
    "CDec";
    "Char";
    "CInt";
    "Class";
    "CLng";
    "CObj";
    "Const";
    "Constraint";
    "Continue";
    "CSByte";
    "CShort";
    "CSng";
    "CStr";
    "CType";
    "CUInt";
    "CULng";
    "CUShort";
    "Date";
    "Decimal";
    "Declare";
    "Default";
    "Delegate";
    "Dim";
    "DirectCast";
    "Do";
    "Double";
    "Each";
    "Else";
    "ElseIf";
    "End";
    "EndIf";
    "Enum";
    "Erase";
    "Error";
    "Event";
    "Exit";
    "False";
    "Finally";
    "For";
    "Friend";
    "Function";
    "Get";
    "GetType";
    "GetXMLNamespace";
    "Global";
    "GoSub";
    "GoTo";
    "Handles";
    "If";
    "If";
    "Implements";
    "Imports";
    "In";
    "Inherits";
    "Integer";
    "Interface";
    "Is";
    "IsNot";
    "Let";
    "Lib";
    "Like";
    "Long";
    "Loop";
    "Me";
    "Mod";
    "Module";
    "MustInherit";
    "MustOverride";
    "MyBase";
    "MyClass";
    "NameOf";
    "Namespace";
    "Narrowing";
    "New";
    "Next";
    "Not";
    "Nothing";
    "NotInheritable";
    "NotOverridable";
    "Object";
    "Of";
    "On";
    "Operator";
    "Option";
    "Optional";
    "Or";
    "OrElse";
    "Out";
    "Overloads";
    "Overridable";
    "Overrides";
    "ParamArray";
    "Partial";
    "Private";
    "Property";
    "Protected";
    "Public";
    "RaiseEvent";
    "ReadOnly";
    "ReDim";
    "REM";
    "RemoveHandler";
    "Resume";
    "Resume";
    "Return";
    "SByte";
    "Select";
    "Set";
    "Shadows";
    "Shared";
    "Short";
    "Single";
    "Statement";
    "Static";
    "Step";
    "Stop";
    "String";
    "Structure";
    "Sub";
    "SyncLock";
    "Then";
    "Throw";
    "To";
    "True";
    "Try";
    "TryCast";
    "Type";
    "TypeOf";
    "UInteger";
    "ULong";
    "UShort";
    "Using";
    "Variant";
    "Wend";
    "When";
    "While";
    "Widening";
    "With";
    "WithEvents";
    "WriteOnly";
    "Xor";
  ]

let singleton_language =
  Language.create ~name:"Visual Basic" ~reserved_keywords ()

let visualbasic () = VisualBasic

let language (vb : t) =
  ignore vb;
  singleton_language
